Codeforces Round #369 (Div. 2) C.Coloring Trees (基础DP)

来源:互联网 发布:淘宝网延长收货时间 编辑:程序博客网 时间:2024/05/20 22:38
传送门:C. Coloring Trees
描述:

C. Coloring Trees
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 1001 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples
input
3 2 20 0 01 23 45 6
output
10
input
3 2 22 1 21 32 43 5
output
-1
input
3 2 22 0 01 32 43 5
output
5
input
3 2 32 1 21 32 43 5
output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题意:

给你n棵树,m种颜色,k是指定最后的完美值。接下来一行n个数 表示1~n树原本的颜色,0的话就是没颜色(一定要上色),非0就是有颜色(不能上色)。

接下来n行 每行m个数,第i行第j个数表示 编号为i的树上第j种颜色的代价为p[i][j]。

问你最后要使完美值为k的上色代价最小为多少,要是不可能的话就为-1。

思路:

设dp[i][x][l]代表涂完前i棵树,美丽值为x,最后一棵树的颜色为l的最小代价。
写出状态转移方程:
for each 1<=c<=m
若第i棵树没颜色
dp[i][x+1][c]=min(dp[i][x+1][c],dp[i-1][x][l]+p[i][c]) , if c!=l
dp[i][x][c]=min(dp[i][x][c],dp[i-1][x][l]+p[i][c]), if c==l
否则
dp[i][x+1][a[i]]=min(dp[i][x+1][a[i]],dp[i-1][x][l]), if c!=l
dp[i][x][a[i]]=min(dp[i][x][a[i]],dp[i-1][x][l]), if c==l

一开始初始化为inf即可。

代码:

#include <bits/stdc++.h>#define ll __int64using  namespace  std;template<class T> void read(T&num) {    char CH; bool F=false;    for(CH=getchar();CH<'0'||CH>'9';F= CH=='-',CH=getchar());    for(num=0;CH>='0'&&CH<='9';num=num*10+CH-'0',CH=getchar());    F && (num=-num);}const ll inf= 0x3f3f3f3f3f3f3f3fLL;ll p[111][111];int a[111];ll dp[111][111][111];int  main(){  std::ios::sync_with_stdio(false);  std::cin.tie(0);  int n,m,k;  read(n);read(m);read(k);  for(int i=1; i<=n; i++)read(a[i]);  for(int i=1; i<=n; i++)    for(int j=1; j<=m; j++)      read(p[i][j]);        for(int i=1; i<=n; i++)    for(int j=1; j<=k; j++)      for(int x=1; x<=m; x++)        dp[i][j][x]=inf;          if(a[1])dp[1][1][a[1]]=0;  else{    for(int c=1; c<=m; c++)      dp[1][1][c]=p[1][c];  }  for(int i=2; i<=n; i++)if(a[i]==0){    for(int x=1; x<i; x++){      for(int c=1; c<=m; c++){        for(int l=1; l<=m; l++){          if(l!=c)dp[i][x+1][c]=min(dp[i][x+1][c], dp[i-1][x][l]+p[i][c]);          else dp[i][x][c]=min(dp[i][x][c], dp[i-1][x][l]+p[i][c]);        }      }    }  }  else{    for(int x=1; x<i; x++){      for(int l=1; l<=m; l++){        if(l!=a[i])dp[i][x+1][a[i]]=min(dp[i][x+1][a[i]], dp[i-1][x][l]);        else dp[i][x][a[i]]=min(dp[i][x][a[i]], dp[i-1][x][l]);      }    }  }  ll ans=inf;  for(int c=1; c<=m; c++)    ans=min(ans, dp[n][k][c]);  if(ans==inf)cout<<-1<<endl;  else cout<<ans<<endl;  return 0;}

反思:做的时候做不怎么来,DP练得有点少了。。。


1 0
原创粉丝点击